
#define Versus  "Version 14/04/13"
// version pour Android AMARINO
/*

* Project name:     voir _18F26K22_DDS_DAC5b_PROJET.jpg
    directory       C:\_C18\_MesProjets_C18\_18F26K22_26K20\
	Project : 	    18F26K22_DDS_DAC5b.mcp
	main Source	:   18F26K22_DDS_130413_ADC5b_BT_JY_MCU_C18.c
	chargeur:       .... ou 1.hex
    linker:         ..\common\18f26k22_GrosseBank.lkr
    Others:         voir 18F26k22_DDS.tmf
    option alternative compilateur C8 : 
    -k --verbose -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa- -nw=2066   -nw=2073 -pa=3

     MCU:             PIC18F26K22
     Dev.Board:       Own breadboard
     Oscillator:      10.0000 MHz Crystal With PLL actived => 40Mhz
     Ext. Modules:    Internal DAC 5 bits with output on RA2

     Software:      MPLAB C18
			        Pickit2
			        Terminal Vray
			        PIC_calculs_datas_120408.xls\UART SPBRG calculator
     outils :       Oscilloscope 2x60Mhz
                    Multimetre FI515X  V,F


 ----------------------------------------------------------------
 history :
 
13 avr 2013
adaptation avec interface Bluetooth ONLY ( ni lcd,ni bp) 
BlueSoleil voit ce peripherique comme
linvor
@mac 20:13:01:24:11:22
led rouge clignotante
liaison a etablir cot PC
led rouge fixe si liaison OK avec COM9 Bluesoleil service du port serie A (COM10) 
test ok apres avoir pass la vitesse a 9600bds (vitesse par defaut du module BT)
dialogue avec VBRAY COM9 (sans fil !)
idem que connct en Rs232 cable.

Adaptation du programme pour appli AMARINO2.0.apk
envoi des flag S,C,T,D,R ..OK pour forme des signaux
rajout FxxxxxCR pour fixer la frequence avec le Flag F
 
===================== 
 
18/03/2013  
Petits amenagement ergonomiques LCD 
suppression affichage sur ecran pendant modif  + ou -, seulement sur validation

16/03/2013 choix sur 64 frequences au lieu de 16 
corrig effet de bords avec augmentation taille de la table de frequences fixes 
 car Grossebank etait declaree en ROM au lieu de RAM. Rajout indice devant la valeur de frequence.
 rajout define Versus 
14/03/2013  ... tests OK
Rajout traitement IT RB0 = 1 des 5 boutons a t appuy (via ou de 5 diodes) : Traite_Bps()
L'IT RB0 permet de sortir de la boucle infinie DDS (si c=0) sans passer par le terminal RS232
Harmonisation des 2 menus  Terminal RS232 et LCD qui ont des tailles de Msg differents
32 car pour terminal et 16 cars pour LCD. Les adresses sont recalcules suivant le mode, et
l'argument pass est alors un numero de msg.
13/03/2013
Rajout de 5 boutons et 1er test
09/03/2013
Rajout LCD 2x6 car
+ gestion de 2+2+1=5 boutons
pour version autonome SANS PC

08/03/2013 .... OK !!
Possibilite de regler l'amplitude de sortie du DAC 1,024  2,048 et 4,096V via touche "A"mplitude
Ampli buffer TLC27M2 en sortie de DA, attaque un potar de reglage fin amplitude => 2em ampli buffer
pour sortie basse impedance , Z mini sans distortion = 750 ohms
Sortie directe amont du potar pour le frequencemetre.

07/03/2013
VERSION avec terminal RS232 ou (Potar reglage + fequencemetre)
Rajout led Up and Down
ESC pour sortir du mode reglage via potar, avec affichage derniere consigne reglee
Test permanent des butees pendant le reglage via potar

06 mar : rajout reglage Freq par potar  Touche P .. reglage..valide par ESC
PB : F=819Hz au lieu de 1000 ??? Why .. apres rajout de code ?
Le probleme est li a l'option du compilateur C18 : Avec activation Integer promotion
le code developp est plus long : 34 cycles au lieu des 27
Recompilation sans l'option Projet Builds options projet compil.C18 Integer promotion
je retrouve mes 1000Hz pour une consigne DDS de 45299
voir DDS_Attention_option_C18.xls

Rajout fonction POTAR pour reglage frequence (SANS PC terminal RS232)
mais alors necessite un frequencemetre reli au gene DDS

05 mars 2013 avec 18F26K22  Q=10MHz  PLL=ON => 40MHZ
RS232 a 38400 bds avec interface 2T
Vbray terminal avec macro 18F26k22_DDS.tmf

rev 05/07/2012  ... A SUIVRE ! ..
 a modifier table sinus ... 32 steps  au lieu de 256
 essai avec DAC 5b interne du PIC au lieu de DAC 8Bits DAC588 externe
 sortie signal sur RA2

 Rajout M comme MARQUEUR  signal maxi sur 3/256 au milieu de la periode
 pour servir de marqueur sur la voie B = calibrage axe X oscillo

 Retour avec table sur 1 seule periode de 256 pas!
 pour ameliorer la linearite de la dent de scie
 et reglage plus fin du Taux rectangle de  1/256 a 255/256 ( au lieu de 1/128 a 127/128)

 Apres recherche d'optimisation de la boucle DDS :
 Modif boucle while (c==0); sur test presence d'un carcatere lu via interrupt UART
 au lieu du test sur les 2 pointeurs de buffer
 et assignation directe du PORTD . PORTD=SIGNAL[U1.ACCU.pv2];
 le 1000Hz passe a 1296Hz !! => gain de temps!!
 => nouveau Coeff_DDS =0.022075794

  	Coeff_DDS pour 40Mhz
	0.044151589; pour 27 cycles APRES OPTIMISATION et while(c==0);
	0.034059797 pour 31 cycles et table 2 periodes avec  while (PIR1bits.RC1IF==0);
	0.034059797 pour 35 cycles et table 2 periodes avec  while (ptlec == ptecr);
    0,042574746 pour 28 cycles et table 2 periodes avec  while (1);

20000,0      905.969
10000,0      452.984
1000,0        45.298
100,0          4.529
10,0             452
1,0		          45


29/04/2012
commandes:STCXDR
S= SINUS
T= TRIANGLE
C= CARRE
D= Dent de Scie
R= Reverse Dent de Scie
X= Rectangulaire avec Taux = valeur ADC0   reglable de 1/128em a 127/128em
M = Mark pic de +-48 points au niveau 48  de 2/256
*********************************************************************************
 Parametres:
 Quartz=10Mhz*4=clock 40Mhz  cycle=4/40 =0,1Sec
 Tr_de_Boucle= 27 cycles * cycle = 2.7 S
 bin24_bits=2^24= 16.777.216
 FFacteur=0,022076  //  =1000000)/(Tr_de_boucle*bin24_bits)
 Frequence =((Cons_DDS*nb_sinusoides*quartzMhz*1000000/4)/Nb_cycles_instruc)/bin24_bits
 ici Nb_sinusoide=1 car 1 sinusoides complete dans la table de stockage amplitude SINE_TABLE
 Frequence desiree=(Tr_de_boucle*bin24_bits*Freq_desiree)/(nb_sinusoides*1000000)
gamme limitee de 1Hz a 40.000Hz
 Cons_DDS :
 pour 1000Hz => 45299


=========== HARDWARE ====================

PIC 18F26K22  DIP 28   microchip  programm avec PICKIT3
27 pf  Q=10Mhz 27pF     PLL 4x active => cycle=0,1S

MCLR   1  -- R=1K----|-- C=1F ------ 0V
          |          |-----R=10K --- +5V
          |-------------------- VPP ICSP

PORTA
 RA0   2  Analog Input    <---- Potar reglage Taux signal rectangulaire
 RA1   3  
 RA2   4  DAC 5 bits output ---> DDS signal
 RA3   5  output .. Led_Down --- 750 -- +5V   (ON si ADC1<480)
 RA4   6  Output .. Led_Neutre   .. 750 ohms +5V
 RA5   7  Output .. Led_Up   --- 750 -- +5V   (ON si ADC1>544)
       8  VSS
 RA7   9  ----- Quartz 10Mhz   C=22pF -- Gnd
 RA6   10 ------ Quartz ---    C=22pF -- Gnd

PortB
 RB0  21  libre
 RB1  22  libre (LCD RW not used)
 RB2  23  
 RB3  24  
 RB4  25  
 RB5  26  
 RB6  27  750 --- ICSP_Clck   Bleu fonc    Pin5 Pickit3
 RB7  28  750 --- ICSP_Data   Bleu clair    Pin4 Pickit3

PORTC
 RC0   11   
 RC1   12   
 RC2   13  
 RC3   14  
 RC4   15  
 RC5   16  Led_Rouge-- 750 --+5V
 RC6   17  TX  UART1 TTL  -- fil vert -- 1000 ---2 RX YC-MCU1 BlueTooth
 RC7   18  RX  UART1 TTL  -- fil jaune-- 1000 ---3 TX YC-MCU1 BlueTooth
                                          0V-----4 0V YC-MCU1 BlueTooth  
                                         +5V-----5 alim YC-MCU1 BlueTooth 
                                          mac@: 20:13:01:24:11:22   linvor  1234
 VSS  8  ----  GND Power
 VSS  19 ----  GND Power
 VDD  20 ----  +5V Power

Interface 2T ou DS275 pour liaison UART TTL <-> RS232 38400 bauds
*/

#include <p18f26k22.h>   /* for TRISB and PORTB declarations */

#include "stdio.h"
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <adc.h>
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>



// config du PIC via MPLAB
// Configure
//      select device
//           choisir PIC18F46K22
// Configurations bits
//         si config du PIC faite par MPLAB ,
//              enlever la coche "Configuration Bits set in code".
// voir Help
//  Topics
//        Pic18
//            config bits settings

#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSHP, PLLCFG=ON, PRICLKEN=ON ,FCMEN=OFF
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF     

// config vue par Pickit3
// 3200 3C19 9D00 0084 C00F E00F 400F
// checksum 03B5


#define Byte unsigned char
#define CLS 12
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define Led_Up       LATAbits.LATA5
#define Led_Centre   LATAbits.LATA4
#define Led_Down       LATAbits.LATA3


#define   BP_Droite PORTCbits.RC0
#define   BP_Gauche PORTCbits.RC1
#define   BP_Incr   PORTCbits.RC2
#define   BP_Decr   PORTCbits.RC3
#define   BP_Valid  PORTCbits.RC4
#define   Led_Rouge PORTCbits.RC5

#define SIZE	64		/* taille buffer */
#define TDRE	0x80



rom const char SINE_TABLE []={  // pour 1 periode !
          0x80,0x82,0x85,0x88,0x8B,0x8E,0x91,0x94,
      0x97,0x9A,0x9D,0xA0,0xA2,0xA5,0xA8,0xAB,
      0xAD,0xB0,0xB3,0xB5,0xB8,0xBB,0xBD,0xC0,
      0xC2,0xC5,0xC7,0xC9,0xCC,0xCE,0xD0,0xD2,
      0xD4,0xD6,0xD8,0xDA,0xDC,0xDE,0xE0,0xE2,
      0xE3,0xE5,0xE6,0xE8,0xE9,0xEB,0xEC,0xED,
      0xEE,0xEF,0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,
      0xF5,0xF6,0xF6,0xF7,0xF7,0xF7,0xF7,0xF7,
      0xF8,0xF7,0xF7,0xF7,0xF7,0xF7,0xF6,0xF6,
      0xF5,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0,0xEF,
      0xEE,0xED,0xEC,0xEB,0xE9,0xE8,0xE6,0xE5,
      0xE3,0xE2,0xE0,0xDE,0xDC,0xDA,0xD8,0xD6,
      0xD4,0xD2,0xD0,0xCE,0xCC,0xC9,0xC7,0xC5,
      0xC2,0xC0,0xBD,0xBB,0xB8,0xB5,0xB3,0xB0,
      0xAD,0xAB,0xA8,0xA5,0xA2,0xA0,0x9D,0x9A,
      0x97,0x94,0x91,0x8E,0x8B,0x88,0x85,0x82,
      0x80,0x7D,0x7A,0x77,0x74,0x71,0x6E,0x6B,
      0x68,0x65,0x62,0x5F,0x5D,0x5A,0x57,0x54,
      0x52,0x4F,0x4C,0x4A,0x47,0x44,0x42,0x3F,
      0x3D,0x3A,0x38,0x36,0x33,0x31,0x2F,0x2D,
      0x2B,0x29,0x27,0x25,0x23,0x21,0x1F,0x1D,
      0x1C,0x1A,0x19,0x17,0x16,0x14,0x13,0x12,
      0x11,0x10,0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,
      0x0A,0x09,0x09,0x08,0x08,0x08,0x08,0x08,
      0x08,0x08,0x08,0x08,0x08,0x08,0x09,0x09,
      0x0A,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,
      0x11,0x12,0x13,0x14,0x16,0x17,0x19,0x1A,
      0x1C,0x1D,0x1F,0x21,0x23,0x25,0x27,0x29,
      0x2B,0x2D,0x2F,0x31,0x33,0x36,0x38,0x3A,
      0x3D,0x3F,0x42,0x44,0x47,0x4A,0x4C,0x4F,
      0x52,0x54,0x57,0x5A,0x5D,0x5F,0x62,0x65,
      0x68,0x6B,0x6E,0x71,0x74,0x77,0x7A,0x7D
   };


rom const char DENT_DE_SCIE_TABLE []={  // pour 1 periode !

    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
    0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
    0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
    0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
    0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
    0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
    0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,
    0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,
    0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,
    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,
    0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
    0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
    0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,
    0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
    0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
    0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
    0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
    0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
    0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
    0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
    0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
    0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
    0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
    0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};


rom const char CARRE_TABLE []={ // pour 1 periode!
           0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00

   };



 rom const char TRIANGLE_TABLE []={  // pour 1 periodes !
      0x08,0x09,0x0B,0x0D,0x0F,0x11,0x13,0x15,
      0x17,0x18,0x1A,0x1C,0x1E,0x20,0x22,0x24,
      0x26,0x27,0x29,0x2B,0x2D,0x2F,0x31,0x33,
      0x35,0x36,0x38,0x3A,0x3C,0x3E,0x40,0x42,
      0x44,0x45,0x47,0x49,0x4B,0x4D,0x4F,0x51,
      0x53,0x54,0x56,0x58,0x5A,0x5C,0x5E,0x60,
      0x62,0x63,0x65,0x67,0x69,0x6B,0x6D,0x6F,
      0x71,0x72,0x74,0x76,0x78,0x7A,0x7C,0x7E,
      0x80,0x81,0x83,0x85,0x87,0x89,0x8B,0x8D,
      0x8F,0x90,0x92,0x94,0x96,0x98,0x9A,0x9C,
      0x9E,0x9F,0xA1,0xA3,0xA5,0xA7,0xA9,0xAB,
      0xAD,0xAE,0xB0,0xB2,0xB4,0xB6,0xB8,0xBA,
      0xBC,0xBD,0xBF,0xC1,0xC3,0xC5,0xC7,0xC9,
      0xCB,0xCC,0xCE,0xD0,0xD2,0xD4,0xD6,0xD8,
      0xDA,0xDB,0xDD,0xDF,0xE1,0xE3,0xE5,0xE7,
      0xE9,0xEA,0xEC,0xEE,0xF0,0xF2,0xF4,0xF6,
      0xF8,0xF6,0xF4,0xF2,0xF0,0xEE,0xEC,0xEA,
      0xE9,0xE7,0xE5,0xE3,0xE1,0xDF,0xDD,0xDB,
      0xDA,0xD8,0xD6,0xD4,0xD2,0xD0,0xCE,0xCC,
      0xCB,0xC9,0xC7,0xC5,0xC3,0xC1,0xBF,0xBD,
      0xBC,0xBA,0xB8,0xB6,0xB4,0xB2,0xB0,0xAE,
      0xAD,0xAB,0xA9,0xA7,0xA5,0xA3,0xA1,0x9F,
      0x9E,0x9C,0x9A,0x98,0x96,0x94,0x92,0x90,
      0x8F,0x8D,0x8B,0x89,0x87,0x85,0x83,0x81,
      0x80,0x7E,0x7C,0x7A,0x78,0x76,0x74,0x72,
      0x71,0x6F,0x6D,0x6B,0x69,0x67,0x65,0x63,
      0x62,0x60,0x5E,0x5C,0x5A,0x58,0x56,0x54,
      0x53,0x51,0x4F,0x4D,0x4B,0x49,0x47,0x45,
      0x44,0x42,0x40,0x3E,0x3C,0x3A,0x38,0x36,
      0x35,0x33,0x31,0x2F,0x2D,0x2B,0x29,0x27,
      0x26,0x24,0x22,0x20,0x1E,0x1C,0x1A,0x18,
      0x17,0x15,0x13,0x11,0x0F,0x0D,0x0B,0x09
      };

#pragma

rom const float Coeff_DDS=0.022075794;  // 27 cycles pour 1 periode  Q=10Mhz x 4 (PLL ON)


rom const char chaine0[]="Frame Erreur et Overflow detection : ";
rom const char chaine1[]="Port comm 9600bds ouvert, liaison Bluetooth JY-MCU";
rom const char chaine2[]="Marquer 2% du signal";
rom const char chaine3[]="ESC pour sortir\r";
rom const char chaine4[]="Capture Taux sur ADC0 ";
rom const char chaine5[]="Sortie Normale de Prg";
rom const char chaine6[]="car recu :";
rom const char chaine7[]="Usage Q=10Mhz x4 (PLL)\r";
rom const char chaine8[]=" Erreur Saisie.....\r";
rom const char chaine9[]=" Init ConsFreq 1Khz\t";
rom const char chaine10[]=" Facteur DDS = ";
rom const char chaine11[]=" Interface via BlueTooth Terminal RS232 \r";
rom const char chaine12[]=" Gamme de 1 a 30.000Hz (up to 60Khz)\r";
rom const char chaine13[]="C18: 18F26K22_DDS_130414_ADC5b_BT_Amarino_C18.c\r";
rom char *Menu_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5,chaine6,chaine7,
                        chaine8,chaine9,chaine10,chaine11,chaine12,chaine13,};
                        
rom const char DAC_Scale[][8]={"........"," 1.024V"," 2.048V"," 4.096V"};



#pragma romdata EEP1_=0xF00000

      rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          " 18F26K22 40Mhz Q=10Mhz PLLx4\r", //0 0   avec terminateur zero
          " Sinus                       \r", //1 20
          " Carre                       \r", //2 40 
          " Triangle                    \r", //3 60 
          " Dent de scie                \r", //4 80 
          " Reverse dent de scie        \r", //5 A0 
          " Rectangle f(Taux)           \r", //6 C0 
          " Reglage Taux Rectangle (pot)\r", //7 E0 
          " Reglage maxi sortie DAC Volt\r", //8 100
          " Reglage Frequence          \r", //9 120 
          "                             \r", //10 140
          "                             \r", //11 160
          "                             \r", //12 180
          " Init sortie DAC maxi: 2,048V\r", //13 1A0
          " MPLAB IDE V8.89,C18 V3.44.  \r", //14 1C0
          " "Versus"  paulfjujo \r"             //15 1E0
          //"Version 16/03/2013 paulfjujo \r"  
          };
  #pragma
  #pragma romdata EEP2_=0xF00200
          rom unsigned char EEPROM_MSG [][16]={
   // tous les msg sont cadres sur 16 cars, donc sans terminateur zero !
         //1234567890123456
         // "Version 16/03/13",//0
          Versus,
          "     SINUS      ",//10   1
          "     Carre      ",//20   2
          "     Triangle   ",//30   3
          " Dents de SCIE  ",//40   4
          "rev Dent de SCIE",//50   5
          "    Rectangle   ",//60   6
          "Regle TAUX Rect.",//70   7
          "Regle Maxi Ampli",//80   8
          "Reglage Frequenc",//90   9
          "                ",//A0   10
          "                ",//B0   11
          "                ",//C0   12
          " >>             ",//D0   13
          " <<             ",//D0   14
          "                " //F0   15
          };      
#pragma



#pragma udata GrossBank
static unsigned char buffer[128];
unsigned int Table_Freq [64]={
1,2,5,10,20,50,100,200,500,750,
1000,1250,1500,1750,2000,2500,2750,3000,3500,4000,
4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,
9500,10000,11000,12000,13000,14000,15000,16000,17000,18000,
19000,20000,21000,22000,23000,24000,25000,26000,27000,28000,
29000,30000,31000,32000,33000,34000,35000,36000,37000,38000,
39000,40000,42500,45000
};
#pragma udata

/*	Variables globales */
unsigned char  SIGNAL[256];

char *Ptr_Signal=&SINE_TABLE[0];       // pointeur sur table ROM
char Texte[64]="PROJET: 18F26K22_DDS.mcp \r";
char *txt=&Texte[0];
unsigned char Entree[16]="123456789012345";
unsigned char *valtxt;
char *ptlec;		/* pointeur de lecture */
char *ptecr;		/* pointeur d'criture */
Byte Drapeau;
Byte receive;
char error;
char EtatCf;
signed char Ve;

int Debugging;
unsigned int dummy;
volatile int CptFO,CptFE;           // compteur erreur UART
volatile unsigned char c;
unsigned short int i,j,k;
int Scaling_DAC;
unsigned char s_count = 0;
unsigned int M,M1;
int ChoixF;
unsigned int Taux;
signed long ConsFreq=0L;
unsigned long Cons_DDS=0L ;
long FDDS[16];
float FConsDDS;
float FConsFreq;
float FFacteur;
float Tx;
float F1;

volatile int Pos_Menu_H;


struct ForByte
{
  near unsigned char pv0;  // ESB
  near unsigned char pv1;  // HSB
  near unsigned char pv2;  // MSB
  near unsigned char pv3;  // LSB
}pV,ACCU;

union
{
  near unsigned long Cons_DDS;
  near struct ForByte pV;
}MV;

union
{
  near unsigned long ACCUMULATEUR;
  near struct ForByte ACCU;
      }U1;


struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned Dummy:1;
                 unsigned Blc:1;
                 unsigned Change:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               }Drapeaux ;

 union
{  unsigned char Fanion;
   struct chbits Drapeaux ;
} Flags;


#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;

unsigned int count;
unsigned int CptCars;
unsigned int SaisieOk;
unsigned int ESC;
unsigned char FREQ_E,FREQ_H,FREQ_M,FREQ_L;
unsigned ACC_E,ACC_H,ACC_M,ACC_L;


//---- EEPROM PIC de 1024 bytes !!!
unsigned char EEPROM_Lect(unsigned int AdrL) ;
void EEPROM_Ecr(unsigned int AdrE,unsigned char car);
void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char * ptr1);
void PrintOut_Eeprom_Msg(unsigned int PtrE);


////--- local Softw RS232 ------
void Init_UART1(void);
void Put_RS(unsigned char c);
int PutStr_RS(char *s);
int PutStr_RS(char *s);
unsigned char Get_RS(void);
char *GetStr_RS(char *s, char finst);
void Raz_Receipt(void);

//---- Other subroutines
void Init_Hardware(void) ;
void Tempo(long int value);
void Idle(void);
void Octet2Hex(unsigned char number);
void Decompile_byte(Byte un);
void Write_Word(unsigned int M);
void print_flt(float W,int NbDeci,char Bold);
void fltToa (float x, unsigned char *str,char precision);
void CRLF(void);
void copyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr);
void ReverseCopyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr);

//----- ADC 10 bit ------
void Init_ADC(void);
//void OpenADC( unsigned char config,unsigned char config2 );
void SetChanADC( unsigned char channel );
char BusyADC( void );		// 1= busy
void ConvertADC( void );
int ReadADC( void );
unsigned int Mesure_ADC(int j) ; // utilise buffer pointe par txt
void CloseADC( void );
void Config_DAC(void);

//--- interrupts
void Traite_ISR(void);

//- Clavier 5 boutons --
void Choix_Sinus(void) ;                   
void Choix_Carre(void) ;    
void Choix_Triangle(void);
void Choix_Dent_de_Scie(void);
void Choix_Reverse_Dent_de_Scie(void);  
void Choix_Rectangle(void);  
void  Calcule_et_Charge_consigne_DDS (signed long CF);   
int  Test_Buttons(void);
void Traite_BPs(void);

//--------- RS232 local software --------------

void Init_UART1(void)
{
// USART_BRGH_HIGH,32
// init 38400Bd a 20Mhz
// init 19200Bd a 10Mhz avec IT en rx
// voir para 18.5 spec sheet DS41159B page 186
// 19200  64  @ 20MHz
// 38400  32  @ 20MHz
// 38400  64  @ 40Mhz  (Q=10Mhz x PLL=4)
// 115200  21 @ 40Mhz

Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
USART_BRGH_LOW,65      //9600 bds
//USART_BRGH_HIGH,64      //38400 bds
);
TXSTAbits.BRGH = 0;    // high data rate for sending
IPR1bits.RC1IP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RC1IE = 0;
INTCONbits.PEIE = 0 ; // autorisation des IT des priphriques
INTCONbits.GIE = 0 ; // autorisation globale des IT
}

int PutStrR_RS(rom char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(unsigned char untel)
{
   	while(Busy1USART());
   	//putc1USART(untel);
   	Write1USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

unsigned char Get_RS(void)
	{
	unsigned char c;
	while (ptlec == ptecr);
	c = *ptlec++;
	if (ptlec >= &buffer[SIZE])	ptlec = buffer;
	return (c);
	}






// ---- init  interruptions ------------------------
// Serial Interrupt
#pragma code highvector=0x0008
void interrupt_at_high_vector(void)
{
_asm   goto Traite_ISR   _endasm
}
#pragma code

#pragma interrupt Traite_ISR
void Traite_ISR(void)	// reception d'une interruption
{
    //char c;
//==== UART interrupt ===========
if ( (PIE1bits.RC1IE == 1) &&(PIR1bits.RC1IF==1)) // si IT Rx UART
{
    c =Read1USART(); // le lire => RAZ  RCIF
   
     if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     Flags.Drapeaux.FrameErr=1;
     CptFE++;
     RCSTA1bits.SPEN= 1 ;
     }
     else
     Flags.Drapeaux.FrameErr=0;

   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       Flags.Drapeaux.Over=1;
       RCSTA1bits.CREN = 1 ;
       CptFO++;
       }
      else
      Flags.Drapeaux.Over=0;

   while( Busy1USART()) ; // par scurite
   //if (PORTBbits.RB1==0) Write1USART(c); // echo
	*ptecr++ = c;
	if (ptecr >= &buffer[SIZE]) ptecr = buffer;
  }
 }



//------  EEPROM  PIC 18FX6K22  1024 bytes !!------------

unsigned char EEPROM_Lect(unsigned int AdrL) 
{ 
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)& 0x03);   //Bits 3-7 are masked off since EEPROM is only 1KB
//	EEADR=(Hi)AdrL;
//	EEADR=(low)AdrL;
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(1000L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr;
    
    if (Drapeaux.Lcd) AdrE=AdrE + 0x02;
    EEADRH = ((AdrE>>8)&0x03);   //Bits 2-7 are masked off since EEPROM is only 1KB
    EEADR =(AdrE &0xFF);
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON1bits.CFGS =0;
  if(INTCONbits.GIE ==1)
    {
    INTCONbits.GIE =0 ;
    dr=1;
    }
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
	if (dr==1)INTCONbits.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ // imprime  N de msg en eeprom until carcatere=0 ou 15 cars maxi si choix LCD
  int i,j;
  // calcule adresse offset du msg 
    if (Drapeaux.Lcd==1) PtrE=(PtrE<<4)+0x0200; else PtrE=PtrE<<5;
    // Numero de msg *16 car pour LCD
    // numero Msg *32 car pour ecran RS232
  j=0;
  do
  {
  if ( PtrE >1023) break;
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;
  Put_RS((Byte)i); 
  PtrE++;j++;
  }
  while (i!=0)  ;
 Tempo(1000L);
}

void Write_Word(unsigned int M)     // entier cadre sur 5 digits complet par des zeros a gauche
{
 unsigned int k,L;
 valtxt=&Entree[0];
 itoa(M,valtxt);
 k=strlen(valtxt);
 for (L=k;L<4;L++) 
 { 
   Put_RS('0');
 } 
  k=PutStr_RS(valtxt);
}


void fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ...
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);
  x *= 10.0;
  }
*str = '\0';
//return (adpt);
}


void print_flt(float W,int NbDeci,char Bold) // avec NbDeci=1,100,1000,10000
{long lWhole;
 unsigned int ulPart;
 Drapeaux.Fill=0;
 lWhole=(long)(W);
 ulPart=(unsigned int)( (float) NbDeci*(W - (float) lWhole));
 ultoa(lWhole,&Texte[0]);
 k=PutStr_RS(Texte);
 Put_RS('.');
 Write_Word(ulPart);
}


//-------------------------

void Config_DAC(void)
{
// init DAC 5bits output

VREFCON0=0x00;
VREFCON0bits.FVREN=1;       // valid Fixed REF. Voltage
VREFCON0bits.FVRS1=0;       // Voltage ref= 1.024V
VREFCON0bits.FVRS0=1;
VREFCON0bits.FVRS=Scaling_DAC;
strcpypgm2ram(Texte,DAC_Scale[Scaling_DAC]);
k=PutStr_RS(Texte);CRLF(); 
Tempo(1000L);
VREFCON1bits.DACEN=1 ;      // valide DAC
VREFCON1bits.DACLPS=0;      // sortie a 0 en mode Low Power
VREFCON1bits.DACOE=1;       // sortie DAC sur PIN
VREFCON1bits.DACPSS1=1;     // DAC positive source is FVR Buff1 output
VREFCON1bits.DACPSS0=0;
VREFCON1bits.DACPSS0=0;
VREFCON1bits.DACNSS=0;      // DAC Negative source is 0V VSS
VREFCON2=0x00;              // output level=0
}






void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
      Put_RS(49u);  //  '1'
    else
      Put_RS(48u);  //  '0'

    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  low=0;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')  low += 7;                        // '9'= 57u
    Put_RS(high);   
    Put_RS(low);
    Put_RS('h'); 
}





void Tempo(long val)
{
while(val>0){val--;}
}


void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)
 {
  Put_RS(' ');
 }
}


void Init_Hardware() {
  PORTB = 0xFF;
  TRISB = 0x01;    // RB0 .input, others as ouput  ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTA = 0b00000111;
  ANSELA=0;
  ANSELAbits.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELAbits.ANSA1=1;
  TRISA = 0b00000111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;

  PORTC = 0xFF;          // RC0..RC4 = input RC5=Output
  ANSELC=0;
  TRISC = 0b10011111;    // 
  TRISCbits.TRISC7 = 1;  // RX - UART1
  TRISCbits.TRISC6 = 0;  // TX - UART1


  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }


void Init_ADC()
 {
       //config lecture ADC 10 bits
 ADCON0bits.ADON=1;      // ADC enabled chanel 0
 ADCON1bits.TRIGSEL=0 ; // trigger from CCP5
 ADCON2bits.ADFM=1;     // right justified
 ADCON2bits.ACQT2=1;
 ADCON2bits.ACQT1=1;
 ADCON2bits.ACQT0=0;    // 16 TAD
 ADCON2bits.ADCS1=1;    // select RA0 = analog input
 ADCON2bits.ADCS2=0;    // RA1 = Analog input
 ADCON2bits.ADCS0=0;    // Fosc/32
 ADCON1bits.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1bits.PVCFG0=0;
 ADCON1bits.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1bits.NVCFG0=0;
 }


 unsigned int Mesure_ADC(int j) // utilise buffer pointe par txt
{
  unsigned int M1,k1;
  //ADCON0bits.ADON=1;
  ADCON0=1 + (j<<2);   // ADON=1 et choix de canal
  Delay10TCYx( 10 ); // Delay for 100TCY
  ConvertADC(); // Start conversion
  while( BusyADC() );
  M1 = ReadADC(); // Read result
 return (M1);
}

void Init_Timer1()
{
 //--- init timer
 //see PIC18F25K22_46K22_41412E.pdf  12.13 page 172
  T1CONbits.TMR1CS1=0;
  T1CONbits.TMR1CS0=0; // clock source= Fosc/4
  T1CONbits.T1CKPS1=1;
  T1CONbits.T1CKPS0=1; // prescaler =1/8
  T1CONbits.T1SOSCEN=0; // Secondary Oscillator Disabled
  T1CONbits.T1SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
  T1CONbits.T1RD16=1 ;  // Mode 16 bits
  T1CONbits.TMR1ON=0;   // Stop timer1
  //---
  T1GCONbits.TMR1GE=0;  // allways count if TMR1ON=1
  T1GCONbits.T1GTM=0;   // Toogle Gate mode disabled
  T1GCONbits.T1GSS1=0;  // Timer1 gate pin
  T1GCONbits.T1GSS0=0;
  //----
  IPR1bits.TMR1IP=1;      // set hihh priority for Timer1
  RCONbits.IPEN = 1;      // Enable High interrupt priority model.
  WriteTimer1(3035);      // 62500*8*4*0.025 => 50S (@40Mhz)
  PIR1bits.TMR1IF=0;      // raz flag interrupt
  INTCONbits.PEIE = 0;    // enable interupt Peripheriques
  T1CONbits.TMR1ON=0;     // desactive Timer1
  PIE1bits.TMR1IE=0;      // Enable Interrupt Timer1
  INTCONbits.GIE = 0;     // active global interrupt
  INTCONbits.GIEL=0;      // active les priorites  (par8 page 79 docu PIC18Fxx8)

}

void copyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr)
{
int i;
i=0;
do
{
*Ramptr++=*Romptr++;
i++;
}while (i<256);
}

void ReverseCopyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr)
{
int i;
i=0;
do
{
*(Ramptr+255-i)=*Romptr++;
i++;
}while (i<256);
}


void Calcule_et_Charge_consigne_DDS (signed long CF)
{
    // calcul equivalent binaire consigne DDS sur 24 bits ( 3 octets)
    // on passe en flottant pour les calculs !
        FConsFreq= (float )CF;
        FFacteur=Coeff_DDS;  //  =(nb_sinusoides*1000000)/(Tr_de_boucle*bin24_bits)
        FConsDDS=  FConsFreq / FFacteur;    // Calcul consigne DDS pour obtenir Freq Out
        MV.Cons_DDS= (long) ceil(FConsDDS); // rangement dans un long 32 bits
       // ultoa(MV.Cons_DDS,&Texte[0]);       // verification en ascii
       // k=PutStr_RS(Texte);
         fltToa (FConsFreq,txt,1);
        k=PutStr_RS(txt);
        Put_RS('H');Put_RS('z');
        CRLF();
        FREQ_L= MV.pV.pv0;
        FREQ_M= MV.pV.pv1;
        FREQ_H= MV.pV.pv2;
        U1.ACCUMULATEUR=0;
}

       
void Raz_Receipt()
{ptecr=buffer;
      ptlec= ptecr;
      CptCars=0;
      c=0;
      receive=0;
 }   
 
      

void Choix_Sinus()
{ 

  PrintOut_Eeprom_Msg(1);
            for (i=0;i<256;i++)
            {
             F1=(float)SINE_TABLE[i]/8.0;
             SIGNAL[i]=(char)(F1);
            }
}
                 
void Choix_Carre()
{
  
    PrintOut_Eeprom_Msg(2);
             for (i=0;i<128;i++) SIGNAL[i]=31;
             for (i=128;i<256;i++) SIGNAL[i]=0;
}                       
    
void Choix_Triangle()
{
    
     PrintOut_Eeprom_Msg(3);
            for (i=0;i<128;i++)
            {
             F1=(float)i/4.0;
             SIGNAL[i]=(char)(F1);
            }
             for (i=128;i<256;i++)
            {
             F1=(float)(255-i)/4.0;
             SIGNAL[i]=(char)(F1);
            }
 }
 
 void Choix_Dent_de_Scie()
 {

     PrintOut_Eeprom_Msg(4);
             for (i=0;i<256;i++)
            {
             F1=(float)i/8.0;
             SIGNAL[i]=(char)(F1);
            }
 }
     
 void Choix_Reverse_Dent_de_Scie()
 {
    // if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
     PrintOut_Eeprom_Msg(5);
             for (i=0;i<256;i++)
            {
             F1=(float)(255-i)/8.0;
             SIGNAL[i]=(char)(F1);
            }
  }
  
  void Choix_Rectangle()
  { //  if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
      PrintOut_Eeprom_Msg(6);
      if ((Taux>0)&&(Taux<255))
        {
             // duree etat HAUT !
               for (i=0;i<Taux;i++)  SIGNAL[i]=31;
             // duree etat BAS !
               for (i=Taux;i<256;i++) SIGNAL[i]=0;
        }       
  }    
  
  

//**************************
//           MAIN
//**************************
 void main()
 {
 Tempo(15000L);
 Init_Hardware() ;
 Debugging=0;
 Led_Rouge=0;    //allume
 
  // init des pointeurs stockage reception car
 ptecr=buffer;
 ptlec= ptecr;
 txt=&Texte[0];
 // init accumulateur DDS
 U1.ACCUMULATEUR=0;



  Flags.Fanion=0;           // <- init globale des flags a Zero
  Flags.Drapeaux.Fill=1;    // <- init individuelle des flags
  Flags.Drapeaux.Blc=1;
  Flags.Drapeaux.Elligible=0; // inutile mais pour la comprehension
  Flags.Drapeaux.Change=0;
  Flags.Drapeaux.Dummy=0;
  Flags.Drapeaux.FrameErr=0;
  Flags.Drapeaux.Over=0;

  CptFE=0;
  CptFO=0;
   ESC=0;

 OUT_RS232
 Init_UART1();	//38400 bauds
 Put_RS(CLS);
 Tempo(200000L);  // laisser un peu de temp pour l'effacement ecran Terminal VBray
 CRLF();

 k=PutStr_RS(txt);   // projet
 CRLF();
 Led_Rouge=1;

 strcpypgm2ram(&Texte[0],Menu_Str[1]);  // port com ouvert
 k=PutStr_RS(Texte);
 CRLF();
 Tempo(10000L);
 strcpypgm2ram(&Texte[0],Menu_Str[13]);  // nom du fichier
 k=PutStr_RS(Texte);
 CRLF();


 strcpypgm2ram(&Texte[0],Menu_Str[11]);
 k=PutStr_RS(Texte);
  strcpypgm2ram(&Texte[0],Menu_Str[12]);
 k=PutStr_RS(Texte);

 PrintOut_Eeprom_Msg(0);      // init RS
 PrintOut_Eeprom_Msg(14);     // version MPLAB
  PrintOut_Eeprom_Msg(15);     // version du programme
 CRLF();
 
strcpypgm2ram(&Texte[0],Menu_Str[10]); // coeff DDS
k=PutStr_RS(Texte);
FFacteur=Coeff_DDS;
fltToa (FFacteur,txt,6);
k=PutStr_RS(txt);
CRLF();

Led_Rouge=0;

Scaling_DAC=2;  // init scaling =2,048V maxi
PrintOut_Eeprom_Msg(13);
Config_DAC();  // init DAC 5bits output
Init_ADC();

SaisieOk=0;

// init table sinus par defaut
 for (i=0;i<256;i++)
            {
             F1=(float)SINE_TABLE[i]/8.0;
             SIGNAL[i]=(char)(F1);
 }
 
 // init signal sinus a 1000Hz
 Pos_Menu_H=1;       // pointe sur libelle EEPROM SINUS 
 ChoixF=10;           // pointeur table freq definies sur le 10em element=1000Hz
 ConsFreq=1000;       // 1000Hz
 strcpypgm2ram(&Texte[0],Menu_Str[9]);
 k=PutStr_RS(Texte);
 U1.ACCUMULATEUR=0; // equivalent a  ACC_L=0;ACC_M=0,ACC_H=0;
 FConsFreq= (float )ConsFreq;
 FConsDDS=  FConsFreq / FFacteur;    // Calcul consigne DDS pour obtenir Freq Out
 MV.Cons_DDS= (long) ceil(FConsDDS); // rangement dans un long 32 bits
 ultoa(MV.Cons_DDS,&Texte[0]);       // verification en ascii
 k=PutStr_RS(Texte);                 // renvoi sur ecran
 CRLF();
 Tempo(10000L);
 Taux=128;   // valeur taux rectangle hors acquis ADC Taux
 
 Calcule_et_Charge_consigne_DDS (ConsFreq);
 
 OUT_RS232
 Tempo(200000L);

 
 
 Led_Rouge=1;
 // ******************   MAIN BOUCLE ******************

  // init pour interruptions ----
  RCONbits.IPEN=1   ; // enable priority levels
  RCONbits.SBOREN=0;  //  BOR disbled
   
 TMR0L=0;  
 WriteTimer0(0);        // init timer0
 T0CON=0b110000100;     //T08BIT=1 TMR0ON=1 T0SE=0  PSA=0  T0PS2:T0PS0=100=1/32 ;
 INTCONbits.TMR0IE =0;
 
 INTCONbits.INT0IE=0;   // disable RB0 interrupt
 RCONbits.IPEN = 0;       // voir page 77 para 8.1
 PIE1=0;
 PIE1bits.RCIE=1 ; // interrupt on Car Receive RX UART
 PIE2=0;
 PIE3=0;
  
  RCSTA1bits.CREN= 1 ;
  PIE1bits.RC1IE = 1;   // autorise interrupt on Car Receive RX UART
  INTCONbits.PEIE = 1;  // autorisation des IT des priphriques
  INTCONbits.GIE = 1;   // active global interrupt
  INTCONbits.GIEL=1;
  
 OUT_RS232
 CptCars=0;
 c=0;
 do
 {
 // saisie 5 digits   00020(CR)... 20000(CR
  if (ptlec != ptecr)
  {
    receive =Get_RS();
    CptCars++;
    OUT_RS232
    switch (receive)
    {
      case 'A' :  // modifie amplitude max 
        {
            PrintOut_Eeprom_Msg(8);
            Scaling_DAC ++;
            if (Scaling_DAC>3)Scaling_DAC=1;
            Config_DAC();
             Raz_Receipt();
            break;
        }
       case 'S' :  // sinus
        {   Pos_Menu_H=1; // met a jour le menu pour le LCD !
            Choix_Sinus();
            Raz_Receipt();
            break;
        }
          case 'C':  // carre
         {   Pos_Menu_H=2;
             Choix_Carre();
             Raz_Receipt();
             break;
         }
        case 'T':  // Triangle
        {    Pos_Menu_H=3;
            Choix_Triangle();
             Raz_Receipt();
            break;
        }
        case 'D':  // dent de scie
        {    Pos_Menu_H=4;
            Choix_Dent_de_Scie();
             Raz_Receipt();
            break;
        }

         case 'R':  // reverse dent de scie
         {  Pos_Menu_H=5;
             Choix_Reverse_Dent_de_Scie();
             Raz_Receipt();
            break;
         }
        case 'Z':  // debugging activation
        {    Debugging=!Debugging;
             Raz_Receipt();
            break;
         }
        case 'X': // Taux
        {   Pos_Menu_H=6;
            PrintOut_Eeprom_Msg(7);
            // rapport cyclique 0 a 100%
            // affiche message demande de Taux

            // reglage via voie ANAN CH0
            // 0 ..1024
            ADCON0=1 ;          // ADON=1 et choix de canal 0
            Delay10TCYx(10);
           ConvertADC();       // Start conversion
            while( BusyADC() );
            Taux = ReadADC();      // Resultat
   
            Tx=(float)Taux*100.0/1024;
            Taux=Taux>>2;  // divise par 4 => 0 a 255
            if ((Taux>0)&&(Taux<255))
            {
             // duree etat HAUT !
               for (i=0;i<Taux;i++)  SIGNAL[i]=31;
             // duree etat BAS !
               for (i=Taux;i<256;i++) SIGNAL[i]=0;
              // strcpypgm2ram(&Texte[0],Menu_Str[4]);
              // k=PutStr_RS(Texte);
               itoa(Taux,txt);
              // Put_RS(TAB);
              Put_RS('M');Put_RS(j+48);Put_RS('=');
              k=PutStr_RS(txt);Put_RS(TAB);
              fltToa (Tx,txt,2);
              k=PutStr_RS(txt);
              Put_RS('%');
              // CRLF();
             }// if M ok
              Raz_Receipt();
            break;
            }
            default:
            {
                break;
           }      
       } // switch   
   } // if receive
   if ((CptCars>6) && (receive=='#') && (buffer[0]=='F') )
   {
       SaisieOk=0;
       CRLF();
       for (i=1;i<6;i++)
       {
         SaisieOk=SaisieOk+isdigit(*(buffer+i));
          Put_RS(*(buffer+i));
        }
        CRLF(); 
       if(SaisieOk!=5)
       {
       //CRLF();
       strcpypgm2ram(&Texte[0],Menu_Str[8]); // err saisie
       k=PutStr_RS(Texte);
       Led_Rouge=0;
       Tempo(2500L);
       Raz_Receipt();
       }
       else
       {
       MV.Cons_DDS=0L;
       buffer[6]=0; //terminateur de string
       // valeur recue via clavier terminal RS232
       ConsFreq=atol(buffer+1);       // numerique
       Calcule_et_Charge_consigne_DDS (ConsFreq); 
       }  // -- test si modif consigne via clavier
     Led_Rouge=1;
     Raz_Receipt();
     Pos_Menu_H=9;
     Tempo(25000L);
    }
  // si erreurs de communication
  if (CptFE>0  || CptFO>0)
  {
      dummy=PutStrR_RS(Menu_Str[0]);
      //Put_RS(TAB);
       Write_Word(CptFE);Put_RS(TAB);Write_Word(CptFO);
      //CRLF();
      Led_Rouge=0;
      Raz_Receipt();
     
   }
  else 
  {
      Led_Rouge=1; // eteint
  }    
  
  //============= partie LCD ==================
       
    j=0;
  // ===  Boucle de fond  DDS ======
  // on ne peut en sortir que sur :
  //  Interrupt reception caractere sur UART (RS232)
  //  Interrupt RB0= appui sur un des 5 BP
    do
    {
    // maj de l'accumulateur 24 bits sans traiter le debordement!
    // avec ADC 5bits du PIC !!
    // cette boucle doit s'executer en exactement 27 cycles machines soit 2,7S Q=10Mhz PLLx4
     VREFCON2=SIGNAL[U1.ACCU.pv2];
     U1.ACCUMULATEUR = U1.ACCUMULATEUR + MV.Cons_DDS ; //& 0x00FFFFFF ;
     }
    while (c==0);
   
   //==========================
   Tempo(2500L);
  }
 while (1)  ;

}

//-------------------   end of  Main --------------------

/*

PROJET: 18F26K22_DDS.mcp 

Port comm 9600bds ouvert, liais0n Bluetooth JY-MCU
C18: 18F26K22_DDS_130413_ADC5b_BT_JY_MCU_C18.c

 Interface via Terminal RS232 ET/OU via Clavier 5 touches + LCD
 Gamme de 1 a 30.000Hz (up to 60Khz)
 18F26K22 40Mhz Q=10Mhz PLLx4
 MPLAB IDE V8.89,C18 V3.44.  
 Version 13/04/13  paulfjujo 

 Facteur DDS = 0.022076
 Init sortie DAC maxi: 2,048V
 2.048V
 Init ConsFreq 1Khz	45299
1000.0Hz
5000.0Hz
5000.0Hz
 Sinus                       
 Carre                       
 Triangle                    
 Dent de scie                
 Reverse dent de scie        
 Reglage maxi sortie DAC Volt
 4.096V
 Reglage maxi sortie DAC Volt
 1.024V
 Reglage maxi sortie DAC Volt
 2.048V
 Reglage Taux Rectangle (pot)
M0=250	97.85% Sinus                       
 Carre                       




*/
